> For a complete documentation index, fetch https://docs.voximplant.ai/llms.txt

# SQ_AddQueue

POST https://api.voximplant.com/platform_api/SQ_AddQueue

Adds a new queue.

**Example request:** Add a new queue.

Reference: https://docs.voximplant.ai/api-reference/management-api/reference/smartqueue/sq-add-queue

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: management-api
  version: 1.0.0
paths:
  /SQ_AddQueue:
    post:
      operationId: sq-add-queue
      summary: SQ_AddQueue
      description: |-
        Adds a new queue.

        **Example request:** Add a new queue.
      tags:
        - subpackage_smartqueue
      parameters:
        - name: application_id
          in: query
          description: Application ID to bind to
          required: true
          schema:
            type: integer
        - name: application_name
          in: query
          description: >-
            Application name to bind to. Can be used instead of
            **application_id**
          required: false
          schema:
            type: string
        - name: sq_queue_name
          in: query
          description: Unique SmartQueue name within the application, up to 100 characters
          required: true
          schema:
            type: string
        - name: hold_im_if_inactive_agents
          in: query
          description: >-
            Whether to add the task to the queue if there are no available
            agents
          required: false
          schema:
            type: boolean
        - name: call_agent_selection
          in: query
          description: >-
            Agent selection strategy for calls. Accepts one of the following
            values: "MOST_QUALIFIED", "LEAST_QUALIFIED", "MAX_WAITING_TIME"
          required: true
          schema:
            type: string
        - name: im_agent_selection
          in: query
          description: >-
            Agent selection strategy for messages. Accepts one of the following
            values: "MOST_QUALIFIED", "LEAST_QUALIFIED", "MAX_WAITING_TIME". The
            default value is **call_agent_selection**
          required: false
          schema:
            type: string
        - name: call_task_selection
          in: query
          description: >-
            Call type requests prioritizing strategy. Accepts one of the
            [SQTaskSelectionStrategies] enum values
          required: true
          schema:
            type: string
        - name: im_task_selection
          in: query
          description: >-
            IM type requests prioritizing strategy. Accepts one of the
            [SQTaskSelectionStrategies] enum values. The default value is
            **call_task_selection**
          required: false
          schema:
            type: string
        - name: hold_calls_if_inactive_agents
          in: query
          description: >-
            Whether to keep the call task in the queue if all agents are in the
            DND/BANNED/OFFLINE statuses.
          required: false
          schema:
            type: boolean
            default: false
        - name: description
          in: query
          description: Comment, up to 200 characters
          required: false
          schema:
            type: string
        - name: call_max_waiting_time
          in: query
          description: >-
            Maximum time in minutes that a CALL-type request can remain in the
            queue without being assigned to an agent. Specify either this
            parameter or `call_max_waiting_time_in_seconds`. Specifying both
            parameters simultaniously leads to an error
          required: false
          schema:
            type: integer
            default: 120
        - name: im_max_waiting_time
          in: query
          description: >-
            Maximum time in minutes that an IM-type request can remain in the
            queue without being assigned to an agent. Specify either this
            parameter or `im_max_waiting_time_in_seconds`. Specifying both
            parameters simultaniously leads to an error
          required: false
          schema:
            type: integer
            default: 120
        - name: call_max_queue_size
          in: query
          description: Maximum size of the queue with CALL-type requests
          required: false
          schema:
            type: integer
            default: 1000
        - name: im_max_queue_size
          in: query
          description: Maximum size of the queue with IM-type requests
          required: false
          schema:
            type: integer
            default: 1000
        - name: priority
          in: query
          description: The queue's priority from 1 to 100
          required: false
          schema:
            type: integer
            default: 10
        - name: call_max_waiting_time_in_seconds
          in: query
          description: >-
            Maximum call waiting time in seconds. Specify either this parameter
            or `call_max_waiting_time`. Specifying both parameters
            simultaniously leads to an error
          required: false
          schema:
            type: integer
        - name: im_max_waiting_time_in_seconds
          in: query
          description: >-
            Maximum chat message waiting time in seconds. Specify either this
            parameter or `im_max_waiting_time`. Specifying both parameters
            simultaniously leads to an error
          required: false
          schema:
            type: integer
        - name: Authorization
          in: header
          description: >-
            Voximplant Management API uses signed JWT tokens generated from your
            service-account private key. Pass the token in the `Authorization`
            header as a Bearer value:


            ```

            Authorization: Bearer $VOXIMPLANT_TOKEN

            ```


            See [Authorization](/api-reference/management-api/authorization) for
            ready-to-copy snippets in bash, Python, Node.js and Go that turn
            your `credentials.json` into a token.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/smartqueue_SQ_AddQueue_Response_200'
servers:
  - url: https://api.voximplant.com/platform_api
components:
  schemas:
    SQAddQueueResult:
      type: object
      properties:
        sq_queue_id:
          type: integer
          description: ID of the added queue
      description: The [SQ_AddQueue] function result.
      title: SQAddQueueResult
    smartqueue_SQ_AddQueue_Response_200:
      type: object
      properties:
        result:
          $ref: '#/components/schemas/SQAddQueueResult'
          description: Result with ID of the added queue
      title: smartqueue_SQ_AddQueue_Response_200
  securitySchemes:
    JwtAuth:
      type: http
      scheme: bearer
      description: >-
        Voximplant Management API uses signed JWT tokens generated from your
        service-account private key. Pass the token in the `Authorization`
        header as a Bearer value:


        ```

        Authorization: Bearer $VOXIMPLANT_TOKEN

        ```


        See [Authorization](/api-reference/management-api/authorization) for
        ready-to-copy snippets in bash, Python, Node.js and Go that turn your
        `credentials.json` into a token.

```

## SDK Code Examples

```python Success
import requests

url = "https://api.voximplant.com/platform_api/SQ_AddQueue"

querystring = {"application_id":"1","sq_queue_name":"sq_queue_name","call_agent_selection":"call_agent_selection","call_task_selection":"call_task_selection"}

headers = {"Authorization": "Bearer <token>"}

response = requests.post(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Success
const url = 'https://api.voximplant.com/platform_api/SQ_AddQueue?application_id=1&sq_queue_name=sq_queue_name&call_agent_selection=call_agent_selection&call_task_selection=call_task_selection';
const options = {method: 'POST', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Success
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.voximplant.com/platform_api/SQ_AddQueue?application_id=1&sq_queue_name=sq_queue_name&call_agent_selection=call_agent_selection&call_task_selection=call_task_selection"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Success
require 'uri'
require 'net/http'

url = URI("https://api.voximplant.com/platform_api/SQ_AddQueue?application_id=1&sq_queue_name=sq_queue_name&call_agent_selection=call_agent_selection&call_task_selection=call_task_selection")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Success
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.voximplant.com/platform_api/SQ_AddQueue?application_id=1&sq_queue_name=sq_queue_name&call_agent_selection=call_agent_selection&call_task_selection=call_task_selection")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Success
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.voximplant.com/platform_api/SQ_AddQueue?application_id=1&sq_queue_name=sq_queue_name&call_agent_selection=call_agent_selection&call_task_selection=call_task_selection', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Success
using RestSharp;

var client = new RestClient("https://api.voximplant.com/platform_api/SQ_AddQueue?application_id=1&sq_queue_name=sq_queue_name&call_agent_selection=call_agent_selection&call_task_selection=call_task_selection");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Success
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/SQ_AddQueue?application_id=1&sq_queue_name=sq_queue_name&call_agent_selection=call_agent_selection&call_task_selection=call_task_selection")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```